import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class info extends HttpServlet {
  
  ServletConfig config;

  public void init(ServletConfig tconfig) throws ServletException {
    super.init(tconfig);
    config=tconfig;}

  public String getServletInfo() {
	  return "A simple diagnostic servlet which lists its initialisation data, information about the http request and its parameters.";}

  private void pp(PrintWriter out, String name, String value) {
	  out.print("<b>"+name+": </b>");
	  if (value==null)
      out.print("<b>none</b>");
    else
      out.print(value);
    out.println("<br>");}
  
  private void pp(PrintWriter out, String name, int value) {
    pp(out, name, String.valueOf(value));}

  public void dostuff(HttpServletRequest req, HttpServletResponse rep) throws ServletException, IOException {
  	rep.setContentType("text/html");
	  PrintWriter out=rep.getWriter();
    out.println("<html>");
	  out.println("<head><title>Info Servlet</title></head>");
	  out.println("<body bgcolor=#89C78C>");
	  out.println("<h1 align=center>Info servlet</h1>");
    out.println("<hr>");
    out.println("<p>This simple diagnostic servlet lists its initialisation data, information about the http request and its parameters.</p>");
    //out.println("<p>This has been modified.</p>");
    out.println("<hr>");
    out.println("<table columns=1 width=100% border=2>");
    out.println("<tr><td><b>Servlet initialisation parameters</b></td></tr>");
    out.println("<tr><td>");
    Enumeration e=config.getInitParameterNames();
    if (!e.hasMoreElements())
      out.println("<b>None!<b>");
    else while (e.hasMoreElements()) {
      String name=(String) e.nextElement();
      String value=config.getInitParameter(name);
      pp(out, name, value);}
    out.println("</td></tr></table><br>");
    out.println("<table columns=1 width=100% border=2>");
    out.println("<tr><td><b>Request information</b></td></tr>");
    out.println("<tr><td>");
    pp(out, "Request method", req.getMethod());
	  pp(out, "Request URI", req.getRequestURI());
	  pp(out, "Request protocol", req.getProtocol());
	  pp(out, "Servlet path", req.getServletPath());
	  pp(out, "Path info", req.getPathInfo());
	  pp(out, "Path translated", req.getPathTranslated());
	  pp(out, "Query string", req.getQueryString());
	  pp(out, "Content length", req.getContentLength());
	  pp(out, "Content type", req.getContentType());
	  pp(out, "Server name", req.getServerName());
	  pp(out, "Server port", req.getServerPort());
	  pp(out, "Remote user", req.getRemoteUser());
	  pp(out, "Remote address", req.getRemoteAddr());
	  pp(out, "Remote host", req.getRemoteHost());
	  pp(out, "Authorization scheme", req.getAuthType());
    out.println("</td></tr></table><br>");
    out.println("<table columns=1 width=100% border=2>");
    out.println("<tr><td><b>Request headers</b></td></tr>");
    out.println("<tr><td>");
    e=req.getHeaderNames();
    if (!e.hasMoreElements())
      out.println("<b>None!<b>");
    else while (e.hasMoreElements()) {
      String name=(String) e.nextElement();
      String value=(String) req.getHeader(name);
      pp(out, name, value);}
    out.println("</td></tr></table><br>");
    out.println("<table columns=1 width=100% border=2>");
    out.println("<tr><td><b>Servlet parameters</b></td></tr>");
    out.println("<tr><td>");
    e=req.getParameterNames();
    if (!e.hasMoreElements())
      out.println("<b>None!<b>");
    else while (e.hasMoreElements()) {
      String name=(String) e.nextElement();
      String value=req.getParameter(name);
      StringBuffer tbuffer=new StringBuffer();
      pp(out, name, value);}
    out.println("</td></tr></table><br>");
    out.println("<p>This page was generated by <i>info</i>, a simple demonstration and diagnostic servlet distributed with <i>vq</i>Server. <i>info</i> and <i>vq</i>Server are produced by <i>vq</i>Soft. Copyright &copy; <i>vq</i>Soft and Steve Shering 1988.");
    out.println("</body></html>");
    out.flush();}

  public void doGet(HttpServletRequest req, HttpServletResponse rep) throws ServletException, IOException {
    dostuff(req, rep);}

  public void doPut(HttpServletRequest req, HttpServletResponse rep) throws ServletException, IOException {
    dostuff(req, rep);}}

